import tornado.web
import tornado.ioloop
import tornado.httpserver
import random

global prize_number,participants,fortunates
global level,number

class IndexHandler(tornado.web.RequestHandler):
    def get(self):
        self.redirect('/setup')

class setting_handler(tornado.web.RequestHandler):
    def get(self):
        self.render("setup.html")

    def post(self):
        try:
            global prize_number,participants,fortunates
            fortunates = {1:[],2:[],3:[]}
            data = self.request.body_arguments
            prize_number = {}
            prize_number[1] = int(data['first_num'][0].decode())
            prize_number[2] = int(data['second_num'][0].decode())
            prize_number[3] = int(data['third_num'][0].decode())
            participants = [x.decode() for x in data['people'] if x]
            if prize_number[1] < 0 or prize_number[2] < 0 or prize_number[3] < 0:
                raise Exception
            if prize_number[1] + prize_number[2] + prize_number[3] > len(participants):
                error_message = '获奖候选人数量不足！'
                self.render("error.html", error_alert=error_message, name=self.reverse_url('setup'))
                return
            self.render("setup_result.html", prize_number=prize_number, participants=participants)
        except:
            error_message = '输入数据不合法！'
            self.render("error.html", error_alert=error_message, name=self.reverse_url('setup'))

class lottery_handler(tornado.web.RequestHandler):
    def get(self):
        global prize_number,participants,fortunates
        if prize_number[1] == 0 and prize_number[2] == 0 and prize_number[3] == 0:
            self.render("lottery_finish.html", fortunates=fortunates, participants=participants)
        else:
            self.render("lottery.html", fortunates=fortunates, prize_number=prize_number, participants=participants)

    def post(self):
        try:
            global prize_number,participants,fortunates
            global level,number
            level = int(self.get_body_argument('level'))
            number = int(self.get_body_argument('number'))
            if level not in [1,2,3]:
                error_message = '奖项等级设置错误！'
                self.render("error.html", error_alert=error_message, name=self.reverse_url('play'))
                return
            if number <= 0:
                raise Exception
            if len(participants) < number:
                error_message = '剩余候选人数量不足！'
                self.render("error.html", error_alert=error_message, name=self.reverse_url('play'))
                return
            if prize_number[level] < number:
                error_message = '该奖项剩余名额不足！'
                self.render("error.html", error_alert=error_message, name=self.reverse_url('play'))
                return
            self.render('lottery_count.html')
        except:
            error_message = '输入数据不合法！'
            self.render("error.html", error_alert=error_message, name=self.reverse_url('play'))

class counting_handler(tornado.web.RequestHandler):
    def get(self):
        global prize_number,participants,fortunates
        global level,number
        lucky_guys = []
        for i in range(number):
            guy = random.choice(participants)
            participants.remove(guy)
            lucky_guys.append(guy)
        fortunates[level] += lucky_guys
        prize_number[level] -= number
        self.render("lottery_result.html", level=level, lucky_guys=lucky_guys)

app = tornado.web.Application(
        [
            (r"/", IndexHandler),
            tornado.web.url(r"/setup", setting_handler, name='setup'),
            tornado.web.url(r"/play", lottery_handler, name='play'),
            (r"/result", counting_handler),
        ],
        template_path='templates',
        static_path='statics'
    )

http_server = tornado.httpserver.HTTPServer(app)
http_server.listen(8888)
tornado.ioloop.IOLoop.current().start()
